
% lab05_ex_blocks_of_butterflies.m
% Radix-2 decimation in time (DIT) FFT algorithm

  clear all; close all;

  N=8;                  % number of signal samples (power of 2 required)
  x=0:N-1;              % exemplary analyzed signal
  Nbit=log2(N);         % number of bits for sample indexes, e.g. N=8, Nbit=3

% Samples reordering (in bitreverse fashion)
  n = 0:N-1;            % indexes
  m = dec2bin(n);       % bits of indexes
  m = m(:,Nbit:-1:1);   % reverse of bits
  m = bin2dec(m);       % new indexes
  y(m+1) = x(n+1);      % data reordering
  y, pause              % checking result

% All 2-point DFTs
  y = [ 1 1; 1 -1] * [ y(1:2:N); y(2:2:N) ]; y=y(:)';

% Butterflies, i.e. spectra reconstruction
  Nlev=Nbit;            % number of levels
  Nfft=2;               % initial Nfft value after 2-point DFTs
  for lev=2:Nlev % LEVELS
      Nfft = 2*Nfft;
      Nblocks = N/Nfft;
      W = exp(-j*2*pi/Nfft*(0:Nfft-1));
      for k = 1:Nblocks % BLOCKS
          y1 = y( 1        + (k-1)*Nfft : Nfft/2 + (k-1)*Nfft );
          y2 = y( Nfft/2+1 + (k-1)*Nfft : Nfft   + (k-1)*Nfft );
          y(1 + (k-1)*Nfft : Nfft + (k-1)*Nfft ) = [ y1 y1 ] + W .* [ y2 y2 ];  % butterflies
      end
  end
  ERROR = max( abs( fft(x) - y ) ), pause
