% lab05_ex_partition2.m

clear all; close all;

N = 64;                  % signal length, N=2^p (power of 2 is required)
x = randn(1,N);          % exemplary signal
X = fft(x);              % its DFT (FFT) calculated by Matlab function

% #######################
% One-level decomposition 
x1 = x(1:2:end);   % even samples
X1 = fft(x1);
x2 = x(2:2:end);   % odd samples
X2 = fft(x2);
Xr = [ X1 X1 ] + exp(-j*2*pi/N*(0:N-1)) .* [ X2 X2 ];  % even/odd spectra combining
error_manual_1 = max( abs(X-Xr) ), pause

% #######################
% Two-level decomposition

% For even samples
x11 = x1(1:2:end);  % even even samples
X11 = fft(x11);
x12 = x1(2:2:end);  % even odd samples
X12 = fft(x12);
X1 = [ X11 X11 ] + exp(-j*2*pi/(N/2)*(0:N/2-1)) .* [ X12 X12 ]; % spectra combining

% For odd samples
x21 = x2(1:2:end);  % odd even samples
X21 = fft(x21);
x22 = x2(2:2:end);  % odd odd samples
X22 = fft(x22);
X2 = [ X21 X21 ] + exp(-j*2*pi/(N/2)*(0:N/2-1)) .* [ X22 X22 ]; % spectra combining

% Combining the even part and the odd part
Xr = [ X1 X1 ] + exp(-j*2*pi/N*(0:N-1)) .* [ X2 X2 ];
error_manual_2 = max( abs(X-Xr) ), pause

% ##############################################
% Calling our recursive multi-level FFT function
Xr = myRecFFT(x);
error_recursive = max( abs(X-Xr) ), pause

% Calling our non-recursive FFT function
Xr = myFFT(x);
error_nonrecursive = max( abs(X-Xr) ), pause
