
% lab05_ex_2in1.m - calculation of two DFTs using one FFT call 
clear all; close all;
N=16;

x1 = randn(1,N);     % Signals
x2 = randn(1,N);
x3(1:2:2*N) = x1;    x3(2:2:2*N) = x2;         % even and odd samples

X1 = fft(x1);        % Their DFT spectra
X2 = fft(x2);
X3 = fft(x3);

% Observe symmetry  of Real(X): Xr(N-k)=Xr(k), k=1,2,...,N-1;
% Observe asymmetry of Imag(X): Xi(N-k)=conj(Xi(k)), k=1,2,...,N-1; Xi(0)=X(N/2)=0;
figure
k = 0:N-1;
subplot(211); hold on
stem(k,real(X1)); xlabel('k'); title('Real(X)');
stem(0,real(X1(1)),'r','filled'); xlabel('k'); title('Real(X)');

subplot(212); hold on
stem(k,imag(X1)); xlabel('k'); title('Imag(X)');
stem(0,imag(X1(1)),'r','filled');
stem(N/2,imag(X1(N/2+1)),'b','filled'); xlabel('k'); title('Real(X)'); pause

% Exploit this symmetry
x12 = x1 + j*x2;    % Artificial complex-value signal
X12 = fft(x12);     % Its DFT spectrum
X12r = real(X12);
X12i = imag(X12);

% Reconstruction of X1 from X12
X1r(2:N) = (X12r(2:N)+X12r(N:-1:2))/2;  % using symmetry  of Real(X1)
X1i(2:N) = (X12i(2:N)-X12i(N:-1:2))/2;  % using asymmetry of Imag(X1)
X1r(1) = X12r(1);
X1i(1) = 0;
X1rec = X1r + j*X1i;
error_X1 = max(abs( X1 - X1rec )), pause

% Reconstruction of X2 from X12
% ... to be done
% Reconstruction of X3 from X1 and X2
% ... to be done
